;
;	L[{̂̃t@C[
;
	ORG	0CE00h

RDINF	EQU	0027h
RDDAT	EQU	002Ah
EXIT	EQU	00ADh
LDERR	EQU	00FEh
NL	EQU	0009h
PRNT	EQU	0012h
LDMSG	EQU	013Eh
PRTHL	EQU	03BAh
MSTOP	EQU	0700h
NAME	EQU	10F1h
SIZE	EQU	1102h
START	EQU	1104h
EXEC	EQU	1106h
KANAF	EQU	1170h
SWRK	EQU	119Dh

RDILoad:	DW	0
RDISize:	DW	0
RDDLoad:	DW	0
RDDSize:	DW	0

Entry:
;
;	{̂[h
;
LD A,'T'
LD (103Bh),A

	CALL	NL
	LD	DE, SetTapeMes
	RST	18h
	CALL	NL
	CALL	09B3h

	CALL	RDINF
	JP	C, LDERR
	CALL	NL
	LD	DE, LDMSG	; 'LOADING'
	RST	18h
	LD	DE, NAME	; FILENAME
	RST	18h
	CALL	RDDAT
	JP	C, LDERR

if 0
	LD	HL, (SIZE)
	LD	(LoaderSize), HL
	LD	A, H
	CP	30h
	JP	NC, NotFound

;
;	[_ۑĂ
;
	OUT	(0E1h), A	; D000h-FFFFh RAM
	LD	HL, (START)
	LD	DE, 0D000h
LoaderSize EQU	$+1
	LD	BC, 0000h
	LDIR
	OUT	(0E3h), A	; D000h-FFFFh VRAM/IO/ROM
endif

;
;	̂悤ȃp^[T
;
;	EF	RST	28h
;	10	DB	10h
;	38 xx	JR	C, xx
;	??
;	??
;	??
;	EF	RST	28h
;	11	DB	11h
;	D2 xxxx	JP	NC, xxxx

	LD	HL, (START)
	LD	BC, (SIZE)
@@:	LD	A, 0EFh		; EF 10 38 T
	CPIR
	JP	PO, NotFound
	LD	A, 10h
	CPI
	JP	PO, NotFound
	JR	NZ, @b
	LD	A, 38h
	CPI
	JP	PO, NotFound
	JR	NZ, @b

	LD	(RDIADDR), HL

	LD	A, 0EFh		; EF 11 D2 T
	CPIR
	JP	PO, NotFound
	LD	A, 11h
	CPI
	JP	PO, NotFound
	JR	NZ, @b
	LD	A, 0D2h
	CPI
	JP	PO, NotFound
	JR	NZ, @b

	LD	(RDDADDR), HL

RDIADDR EQU $+1
	LD	BC, 0000h	; ҂߂΂Ԃ񂱂
	OR	A
	SBC	HL, BC
	LD	A, H
	OR	A
	JR	NZ, @b
	LD	A, L
	CP	16
	JR	NC, @b

;
;	RDI, RDĎĂяoɃpb`𓖂Ă
;
Found:
	LD	HL, (RDIADDR)
	LD	(HL), 00h
	DEC	HL
	LD	(HL), RDIPatch >> 8
	DEC	HL
	LD	(HL), RDIPatch & 0FFh
	DEC	HL
	LD	(HL), 0CDh

RDDADDR EQU $+1
	LD	HL, 0000h	; (RDDADDR)
	DEC	HL
	LD	(HL), RDDPatch >> 8
	DEC	HL
	LD	(HL), RDDPatch & 0FFh
	DEC	HL
	LD	(HL), 0CDh

;
;	{̂s
;
	LD	HL, (EXEC)
	JP	(HL)

NotFound:
	LD	DE, NotFoundMes
	RST	18h
	CALL	NL
	JP	EXIT

NotFoundMes:
	DB	"GIVE UP.", 0Dh

SetTapeMes:
	DB	"SET TAPE AND PRESS ANY KEY", 0Dh

;
;	RDI pb`
;
RDIPatch:
	POP	HL
	LD	(RDIPatchAddr), HL
	RST	28h
	DB	10h
	LD	(RDILoad), HL
	LD	(RDISize), BC
	LD	HL, (RDIPatchAddr)
	JP	(HL)

;
;	RDD pb`
;
RDDPatch:
	POP	HL
	LD	(RDDPatchAddr), HL
	RST	28h
	DB	11h
	LD	(RDDLoad), HL
	LD	(RDDSize), BC

;
;	0`(RDDLoad+RDDSize) ͈̔͂Z[u
;

;
;	{̖̂ɓ][`ǉ
;
	ADD	HL, BC		; HL = RDDLoad + RDDSize
	LD	(TransSize), HL
	EX	DE, HL		; DE = RDDLoad + RDDSize
	LD	HL, Trans
	LD	BC, TransEnd - Trans
	LDIR

;
;	[_Ԃɖ߂
;
	EXX
if 0
	LD	HL, (LoaderSize)
	LD	BC, -16		; IWi̓]vOO
	ADD	HL, BC
	LD	(@1f+1), HL
	LD	BC, (RDDLoad)
	OR	A
	SBC	HL, BC
	JR	NC, @f		; [_̖{̂̊JnAhX𒴂ĂƂ́A{̂̊JnAhXŃNbv
@1:	LD	BC, 0000h
@@:	LD	HL, 0D010h
	LD	DE, 0000h
	OUT	(0E1h), A
	LDIR
	OUT	(0E3h), A
endif

;
;	RDI, RDĎĂяoɍēxpb`𓖂Ă
;
RDIPatchAddr EQU $+1
	LD	HL, 0000h
	XOR	A
	LD	(HL), A		; JR C,xx --> NOP
	DEC	HL
	LD	(HL), A		; JR C,xx --> NOP
	DEC	HL
	LD	(HL), A		; DB 10h  --> NOP
	DEC	HL
	LD	(HL), A		; RST 28h --> NOP

RDDPatchAddr EQU $+1
	LD	HL, 0000h
	DEC	HL
	LD	(HL), 0C3h	; JP NC,xx --> JP
	DEC	HL
	LD	(HL), A		; DB 11h   --> NOP
	DEC	HL
	LD	(HL), A		; RST 28h  --> NOP
	EXX

;
;	0000h`̖{̂ 1200h`ɂ炷
;
	EX	DE, HL
	DEC	HL		; HL = AhX(0000hJn)
	LD	E, L		; DE = AhX(0000hJn) + 1200h
	LD	A, H
	ADD	A, 12h
	LD	D, A
	LD	(EndAddr), DE
	LD	BC, (TransSize)
	LD	A, C
	ADD	A, TransEnd - Trans
	LD	C, A
	JR	C, @f
	INC	B
@@:	LDDR

;
;	Z[uR}h\
;
	OUT	(0E4h), A
	LD	SP, 10F0h
	CALL	MSTOP		; MOTOR OFF
	LD	A, 16h
	CALL	PRNT
	LD	DE, SetBlankTapeMes
	RST	18h
	CALL	NL
	LD	A, '*'
	CALL	PRNT
	LD	A, 'S'
	CALL	PRNT
	LD	HL, 1200h
	CALL	PRTHL
EndAddr EQU	$+1
	LD	HL, 0000h
	CALL	PRTHL
	LD	BC, 1 - (TransEnd - Trans)
	ADD	HL, BC
	CALL	PRTHL
	CALL	NL
	XOR	A
	LD	(KANAF), A
	INC	A
	LD	(SWRK), A
	JP	EXIT

SetBlankTapeMes:
	DB	"SET BLANK TAPE AND SAVE AS FOLLOWS", 0Dh

;
;	{̖̂ɂ][`
;
Trans:	DI
	OUT	(0E0h), A	; 0000h-0FFFh DRAM
	LD	HL, 1200h
	LD	DE, 0000h
TransSize EQU	$+1
	LD	BC, 0001h
	LDIR
	JP	0000h
TransEnd:

	END	Entry
